    function f = DCfun(x,h,PH)
    %parameter initialization
    A = 207; Cv = 8.75; Fbf = 0.55;
    Wba = -3.05e-3; Wbfa = -0.03; Wab = 0;
    Wbb = 5e-5; Wbfb = 0.03; Waa = 0.003;
    Ka1 = 4.4e-7; Ka2 = 5.6e-11; Kw = 1e-14;
    
    H = 10^(-PH);
    
    A1 = H^4 + Ka1 * H^3 + (Ka1 * Ka2 - Kw) * H^2 -Ka1 * Kw * H - Ka1 * Ka2 * Kw;
    B1 = -(H^3 + Ka1 * H^2 + Ka1 *Ka2 * H);
    C1 = -(Ka1 * H^2 + 2 * Ka2 * Ka1 * H);    
    
    
    f(1) = (Waa-x(2))*x(1)+(Wba-x(2))*(Cv*sqrt(h) - x(1) - Fbf)+(Wbfa-x(2))*Fbf;
    f(2) = (Wab-((A1+B1*x(2))/(-C1)))*x(1)+(Wbb-((A1+B1*x(2))/(-C1)))*(Cv*sqrt(h) - x(1) - Fbf)+(Wbfb-((A1+B1*x(2))/(-C1)))*Fbf;
