clear
clc
s = zpk('s'); 
%% plant transfer function
plant = [tf([-1.87],[107.5 1]) tf([1.87],[79.4 1]) ; tf([0.88],[185 1]) tf([0.88],[185 1])];

%% uncertainty weighting function
k11 = 10^(-0.67/20);
k22 = 10^(-1.2/20); 
a = 0.007;
b = a / (k22 / k11);

W = 1*[k11 * tf([1 a],[1 b]) 0 ; 0 k11 * tf([1 a],[1 b])];
%wt_1 = inv(wt);
%%   augmented plant
%Gw = plant * wt;
%% performance weighting function
Ws = [(0.05)*(s + 0.05)/(s + 1e-7) 0;...
      0 (0.05)*(s + 0.005)/(s + 1e-7)];

%% Actuator effort weighting function
Wu = 0.6*[1 0 ; 0 1];


%%  Now that the plant and the weight have been defined, systemnames =  'Gw w_1 wu ws';
% systemnames =  'Gw wt_1 wu ws';
% inputvar    =  '[yd{2} ; u{2}]';
% outputvar   =  '[Gw ; ws ; wu ; yd - wt_1]';
% input_to_Gw =  '[u]';
% input_to_wt_1 ='[Gw]';
% input_to_wu =  '[u]';
% input_to_ws =  '[yd - wt_1]';
% sysoutname =   'G_hinf';
% cleanupsysic = 'yes';
% sysic
G_hinf=augw(plant,Ws,Wu,W);
%G_hinf = minreal(G_hinf);
[k1,g1,gamma1,info1] = hinfsyn(G_hinf,2,2,'Display','on','To',1e-4);
clp_hinf=g1;
k1_hinf=k1;
% %[k1_red,info2] = reduce(k1,5);
omega = logspace(-3,2,200);
g1=tf(g1);
% %omega=logspace(-1,5,500);
sig_g1=sigma(g1,omega);
semilogx(omega,sig_g1(1,:),'b')
hold on
S=[g1(1,1) g1(1,2);g1(2,1) g1(2,2)];
sig_S=sigma(S,omega);
semilogx(omega,sig_S(1,:),'r')
hold on
U=[g1(3,1) g1(3,2);g1(4,1) g1(4,2)];
sig_U=sigma(U,omega);
semilogx(omega,sig_U(1,:),'g')
hold on
T=[g1(5,1) g1(5,2);g1(6,1) g1(6,2)];
sig_T=sigma(T,omega);
semilogx(omega,sig_T(1,:),'k')
grid off
d=legend('\sigma_{max}','WT','W_sS','W_uU')
xlabel('Frequency (rad/s)')

set(d,'FontSize',12)
%figure
m=get(d,'parent')
%axes
n=get(m,'CurrentAxes')
set(n,'FontSize',12,'XLim',[0.01 1e+02])
xlabel('Frequency (rad/s)')
%line
k=get(n,'Children')
set(k(1),'LineWidth',2)
set(k(2),'LineWidth',2)
set(k(3),'LineWidth',2)
set(k(4),'LineWidth',2)

gtext('\sigma_{max}')

gtext('W_sS')
gtext('W_uU')
gtext('WT')

[k1_red,info2] = reduce(k1,4);
omega = logspace(-3,3,200); 
sv1 = sigma(k1,omega);
sv2 = sigma(k1_red,omega);
 
subplot(2,1,1);
plot(omega,20*log10(sv1(1,:)),'linewidth',2);hold on;
plot(omega,20*log10(sv2(1,:)),'--r','linewidth',2);
legend('max sv for k1','max sv for k1_{reduced}');grid on
 
subplot(2,1,2);
plot(omega,20*log10(sv1(2,:)),'linewidth',2);hold on;
plot(omega,20*log10(sv2(2,:)),'--r','linewidth',2);
legend('min sv for k1','min sv for k1_{reduced}');grid on